﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Checkins
{
    public class History
    {
        private const string URL = "http://api.foursquare.com/v1/history";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.GET;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// Returns a history of checkins for the authenticated user.
        /// </summary>
        /// <param name="returnFormat"></param>
        public History()
        {
            
        }

        public List<Schema.Checkin> Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_Limit);
            Parameters.Add(_SinceId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<FoursquareNET.Schema.CheckinsObj>(result).Checkins;
        }

        #region Parameters

        private Parameter _Limit = new Parameter("Limit", "l", false);
        private Parameter _SinceId = new Parameter("SinceId", "sinceid", false);

        /// <summary>
        /// limit of results (optional, default: 20, max: 250). number of checkins to return
        /// </summary>
        public int? Limit { set { _Limit.Value = value.HasValue ? value.ToString() : string.Empty; } }

        /// <summary>
        /// id to start returning results from (optional, if omitted returns most recent results)
        /// </summary>
        public string SinceId { set { _SinceId.Value = value; } }

        #endregion
    }
}
