﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Friend
{
    public class DenyRequest
    {
        private const string URL = "http://api.foursquare.com/v1/friend/deny";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.POST;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// Denies a pending friend request from another user. On success, returns the user object.
        /// </summary>
        /// <param name="returnFormat"></param>
        public DenyRequest()
        {
            
        }

        public Schema.User Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_UserId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.UserObj>(result).User;
        }

        #region Parameters

        private Parameter _UserId = new Parameter("UserId", "uid", true);

        /// <summary>
        /// the user ID of the user who you want to deny
        /// </summary>
        public int UserId { set { _UserId.Value = value.ToString(); } }

        #endregion
    }
}
