﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Friend
{
    public class FindByName
    {
        private const string URL = "http://api.foursquare.com/v1/findfriends/byname";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.GET;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// When passed a free-form text string, returns a list of matching user objects. The method only returns matches of people with whom you are not already friends.
        /// </summary>
        /// <param name="returnFormat"></param>
        public FindByName()
        {
            
        }

        public List<Schema.User> Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_Query);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.UsersObj>(result).Users;
        }

        #region Parameters

        private Parameter _Query = new Parameter("Query", "q", true);

        /// <summary>
        /// the string you want to use to search firstnames and lastnames
        /// </summary>
        public string Query { get { return _Query.Value; } set { _Query.Value = value; } }

        #endregion
    }
}
