﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Friend
{
    public class FindByPhone
    {
        private const string URL = "http://api.foursquare.com/v1/findfriends/byphone";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.GET;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// When passed phone number(s), returns a list of matching user objects. The method only returns matches of people with whom you are not already friends. You can pass a single number as a parameter, or you can pass multiple numbers separated by commas.
        /// </summary>
        /// <param name="returnFormat"></param>
        public FindByPhone()
        {
            
        }

        public List<Schema.User> Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_Query);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.UsersObj>(result).Users;
        }

        #region Parameters

        private Parameter _Query = new Parameter("Query", "q", true);

        /// <summary>
        /// the string you want to use to search for phone numbers
        /// </summary>
        public string Query { set { _Query.Value = value; } }

        #endregion
    }
}
