﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Friend
{
    public class SendRequest
    {
        private const string URL = "http://api.foursquare.com/v1/friend/sendrequest";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.POST;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// Sends a friend request to another user. On success, returns the user object.
        /// </summary>
        /// <param name="returnFormat"></param>
        public SendRequest()
        {
            
        }

        public Schema.User Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_UserId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.UserObj>(result).User;
        }

        #region Parameters

        private Parameter _UserId = new Parameter("UserId", "uid", true);

        /// <summary>
        /// the user ID of the user to whom you want to send a friend request
        /// </summary>
        public int UserId { set { _UserId.Value = value.ToString(); } }

        #endregion
    }
}
