﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Tip
{
    public class MarkTodo
    {
        private const string URL = "http://api.foursquare.com/v1/tip/marktodo";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.POST;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// Allows you to mark a tip as a to-do item.
        /// </summary>
        /// <param name="returnFormat"></param>
        public MarkTodo()
        {
            
        }

        public Schema.Tip Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_TipId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.TipObj>(result).Tip;
        }

        #region Parameters

        private Parameter _TipId = new Parameter("TipId", "tid", true);

        /// <summary>
        /// the tip that you want to mark to-do (required)
        /// </summary>
        public int TipId { set { _TipId.Value = value.ToString(); } }
        
        #endregion
    }
}
