﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.User
{
    public class GetFriends
    {
        private const string URL = "http://api.foursquare.com/v1/friends";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.GET;
        
        private List<Parameter> Parameters = new List<Parameter>();

        /// <summary>
        /// Returns a list of friends. If you do not specify uid, the authenticating user's list of friends will be returned. 
        /// If the friend has allowed it, you'll also see links to their Twitter and Facebook accounts.
        /// </summary>
        /// <param name="returnFormat"></param>
        public GetFriends()
        {
            
        }

        public List<Schema.User> Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_UserId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<FoursquareNET.Schema.FriendObj>(result).Friends;
        }

        #region Parameters

        private Parameter _UserId = new Parameter("UserId", "uid", false);

        /// <summary>
        /// user id of the person for whom you want to pull a friend graph (optional)
        /// </summary>
        public int? UserId { set { _UserId.Value = value.HasValue ? value.ToString() : string.Empty; } }

        #endregion
    }
}
