﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Venue
{
    public class FlagClosed
    {
        private const string URL = "http://api.foursquare.com/v1/venue/flagclosed";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.POST;
        
        private List<Parameter> Parameters = new List<Parameter>();

        public FlagClosed()
        {
            
        }

        public string Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_VenueId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);
            
            return result;
        }

        #region Parameters

        private Parameter _VenueId = new Parameter("VenueId", "vid", true);

        /// <summary>
        /// the venue that you want marked closed (required)
        /// </summary>
        public int VenueId { set { _VenueId.Value = value.ToString(); } }

        #endregion
    }
}
