﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FoursquareNET.Venue
{
    public class GetDetail
    {
        private const string URL = "http://api.foursquare.com/v1/venue";
        private const Common.HttpRequestMethod HTTP_REQUEST_METHOD = Common.HttpRequestMethod.GET;
        
        private List<Parameter> Parameters = new List<Parameter>();

        public GetDetail()
        {
            
        }

        public Schema.Venue Execute()
        {
            return Execute(new Credential());
        }

        public Schema.Venue Execute(Credential credential)
        {
            Parameters.Clear();
            Parameters.Add(_VenueId);

            string result = Common.HTTPPost(URL, Parameters, credential, HTTP_REQUEST_METHOD);

            return new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<Schema.VenueObj>(result).Venue;
        }

        #region Parameters

        private Parameter _VenueId = new Parameter("VenueId", "vid", false);

        /// <summary>
        /// the ID for the venue for which you want information 
        /// </summary>
        public int VenueId { set { _VenueId.Value = value.ToString(); } }

        #endregion
    }
}
